
/*
   Ŀ
                                                                             
     CXLSTR.H - CXL (c) 1987, 1988 by Mike Smedley.                          
                                                                             
     This header file contains function prototypes and definitions for       
     string manipulating functions.                                          
                                                                             
   
*/


#if defined(__TURBOC__)                             /*  Turbo C  */
    #if __STDC__
        #define _Cdecl
    #else
        #define _Cdecl  cdecl
    #endif
    #define _Near
#elif defined(__ZTC__)                              /*  Zortech C++  */
    #define _Cdecl
    #define _Near
#elif defined(M_I86) && !defined(__ZTC__)           /*  Microsoft C/QuickC  */
    #if !defined(NO_EXT_KEYS)
        #define _Cdecl  cdecl
        #define _Near   near
    #else
        #define _Cdecl
        #define _Near
    #endif
#elif defined(__POWERC__)                           /*  Power C  */
    #define _Cdecl
    #define _Near
#endif


/*---------------------------[ Function Prototypes ]-------------------------*/

int      _Cdecl cvaltype(int ch,int ctype);
int      _Cdecl strblank(char *str);
char    *_Cdecl strbmatch(char *str,char *strarr[]);
int      _Cdecl strchg(char *str,int oldch,int newch);
char    *_Cdecl strcode(char *str,char *key);
char    *_Cdecl strdel(char *substr,char *str);
int      _Cdecl strichg(char *str,int oldch,int newch);
char    *_Cdecl stridel(char *substr,char *str);
char    *_Cdecl striinc(char *str1,char *str2);
char    *_Cdecl strinc(char *str1,char *str2);
char    *_Cdecl strins(char *instr,char **str,int st_pos);
int      _Cdecl striocc(char *str,int ch);
char    *_Cdecl strltrim(char *str);
int      _Cdecl strmatch(char *str1,char *str2);
char    *_Cdecl strmid(char *str,int st_pos,int num_chars);
int      _Cdecl strocc(char *str,int ch);
char    *_Cdecl strrol(char *str,int count);
char    *_Cdecl strror(char *str,int count);
char    *_Cdecl strsetsz(char **str,int newsize);
char    *_Cdecl strshl(char *str,int count);
char    *_Cdecl strshr(char *str,int count);
char    *_Cdecl strtrim(char *str);
char    *_Cdecl struplow(char *str);
int      _Cdecl touplow(char *str,char *pos,int ch);


/*-----------------------[ Macro-Function Definitions ]----------------------*/

#define strleft(st,nu)      strmid(st,0,nu)
#define strright(st,nu)     strmid(st,strlen(st)-nu,nu)
#define strrtrim(st)        strtrim(st)
